#!/bin/bash

# This is a tiny little shell script for all the lazy folks out there.

if [ $(whoami) != "root" ]
then
    echo "You have to be root to do this."
else
    echo "Making sure we have all the required packages..."
    apt update
    apt -y install git build-essential raspberrypi-kernel-headers
    echo "Everything fine, installing the module."

    if [ -d /usr/src/sevenseg-0.1 ]
    then
        rm -rf /usr/src/sevenseg-0.1/*
    else
        mkdir /usr/src/sevenseg-0.1
    fi
    cd /usr/src/sevenseg-0.1
    git clone https://mygit.th-deg.de/fk16790/SevenSegController.git
    echo "Building the module..."
    mv SevenSegController/* .
    rm -r SevenSegController
    make all
    echo "Build successful, loading the module..."
    insmod sevenseg.ko
    
    if [ -d /lib/modules/$(uname -r)/kernel/drivers/sevenseg ]
    then
        rm -rf /lib/modules/$(uname -r)/kernel/drivers/sevenseg/*
    else
        mkdir /lib/modules/$(uname -r)/kernel/drivers/sevenseg
    fi
    cp sevenseg.ko /lib/modules/$(uname -r)/kernel/drivers/sevenseg/
    echo "sevenseg" >> /etc/modules
    echo "Module loaded and ready to rock!"
fi